/*
These are queries to run against the database given for the assignment.
See the "SQL data creation.sql" for initializing the database/schema.
For each query you need to describe what it does.
*/

/* Use this database or change to whatever you used. ONLY FOR MYSQL. 
   CAN REMOVE FOR POSTGRESQL BY PUTTING -- AT THE START OF THE LINE. */
use `yourname`;

/* Q1 */
SELECT S.sname 
FROM  s1 S 
WHERE  S.sid IN  (SELECT  R.sid 
                  FROM  r1 R 
                  WHERE  R.bid = 103)
;

/* Q2 */
SELECT S.sname 
FROM  s1 S 
WHERE  S.sid NOT IN  (SELECT  R.sid 
                      FROM  r1 R 
                      WHERE  R.bid = 103)
;

/* Q3 */
SELECT  S.sname 
FROM  s1 S WHERE EXISTS  (SELECT  *  
                          FROM  r1 R 
                          WHERE  R.bid = 103 AND S.sid = R.sid)
;

/* Q4 */
SELECT  S.sid 
FROM  s1 S, b2 B, r1 R 
WHERE  S.sid = R.sid AND R.bid = B.bid AND (B.color = 'red' OR B.color = 'green')
;

/* Q5 */
SELECT  S.sid 
FROM  s1 S, b2 B, r1 R 
WHERE  S.sid = R.sid AND R.bid = B.bid AND B.color = 'red' union 
  (select S2.sid 
  FROM  s1 S2, b2 Bb, r1 R2 
  WHERE  S2.sid = R2.sid AND R2.bid = Bb.bid AND Bb.color = 'green')
;

/* Q6 */
SELECT S.sid 
FROM s1 S, b2 B1, r1 R1, b2 B2, r1 R2 
WHERE S.sid = R1.sid AND R1.bid = B1.bid AND S.sid = R2.sid AND R2.bid = B2.bid AND 
  (B1.color='red' AND B2.color='green')
; 

/* Q7 */
SELECT S.sname 
FROM s2 S 
WHERE S.rating = 
  (SELECT MAX(S2.rating) 
  FROM s2 S2)
;

/* Q8 */
SELECT S.rating, MIN(S.age) AS minage
FROM s5 S 
WHERE S.age >= 18 
GROUP BY S.rating 
HAVING  COUNT(*) > 1
;
